import java.awt.event.ActionEvent;

import javax.swing.JButton;

import acm.graphics.GImage;
import acm.program.GraphicsProgram;
import acm.program.Program;

public class InteractiveKarel extends GraphicsProgram { 
	static final long serialVersionUID = 1;

	public void init() { 
    	initControlStrip(); 
		initKarel(); 
      	addActionListeners(); 
 	} 

	public void actionPerformed(ActionEvent e) { 
      	String cmd = e.getActionCommand(); 
      	if (cmd.equals("movie")) { 
       		move(); 
      	} else if (cmd.equals("turnLeft")) { 
        	turnLeft(); 
      	} 
   	} 

	private void initKarel() { 
      	karel = new GImage("KarelEast.jpg"); 
      	karel.setSize(KAREL_SIZE, KAREL_SIZE);
      	x = 0; 
      	y = getHeight() - KAREL_SIZE; 
      	dir = EAST; 
      	add(karel, x, y); 
   	} 

	private void move() { 
      	double nx = x; 
      	double ny = y; 
      	switch (dir) { 
        	case NORTH: ny -= KAREL_SIZE; break; 
        	case EAST:  nx += KAREL_SIZE; break; 
        	case SOUTH: ny += KAREL_SIZE; break; 
        	case WEST:  nx -= KAREL_SIZE; break; 
      	} 
      	if (isKarelOnScreen(nx, ny)) { 
         	x = nx; 
         	y = ny; 
         	karel.setLocation(x, y); 
      	} 
   }


	private void turnLeft() { 
      	switch (dir) { 
        	case NORTH: 
         		dir = WEST; 
         		karel.setImage("KarelWest.jpg"); 
         		karel.setSize(KAREL_SIZE, KAREL_SIZE);
         		break; 
        	case EAST: 
         		dir = NORTH; 
         		karel.setImage("KarelNorth.jpg"); 
         		karel.setSize(KAREL_SIZE, KAREL_SIZE);
         		break; 
        	case SOUTH: 
         		dir = EAST; 
         		karel.setImage("KarelEast.jpg"); 
         		karel.setSize(KAREL_SIZE, KAREL_SIZE);
         		break; 
       		case WEST: 
         		dir = SOUTH; 
         		karel.setImage("KarelSouth.jpg"); 
         		karel.setSize(KAREL_SIZE, KAREL_SIZE);
         		break; 
     	} 
  	} 

	private boolean isKarelOnScreen(double x, double y) { 
    	return (x >= 0) && (y >= 0) 
        		&& (x + KAREL_SIZE <= getWidth()) 
              	&& (y + KAREL_SIZE <= getHeight()); 
   	} 

	private void initControlStrip() { 
      	add(new JButton("movie"), Program.SOUTH); 
      	add(new JButton("turnLeft"), Program.SOUTH); 
   	} 

	private GImage karel; 
   	private double x; 
   	private double y; 
   	private int dir; 

	private static final int KAREL_SIZE = 64; 
   	private static final int NORTH = 0; 
   	private static final int EAST = 1; 
   	private static final int SOUTH = 2;
	private static final int WEST = 3;
}
